%define name	qemu
%define version	0.6.1
%define release	2mdk
%define targets	i386-user i386-fast i386-softmmu ppc-user ppc-softmmu sparc-user sparc-softmmu

%define __find_requires %{_builddir}/%{name}-%{version}/find_requires.sh

Summary:	QEMU CPU Emulator
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	%{name}-%{version}.tar.bz2
#Patch0:	qemu-0.6.0-i386-cvsupdates.patch.bz2
Patch1:		qemu-0.6.1-DESTDIR.patch.bz2
#Patch2:	qemu-0.6.0-ppc-siginfo.patch.bz2
#Patch3:	qemu-0.6.0-sigaction.patch.bz2
Patch4:         qemu-0.6.0-memleak.patch.bz2
License:	GPL
URL:		http://fabrice.bellard.free.fr/qemu/
Group:		Emulators
BuildRequires:	glibc-static-devel 
# BuildRequires:	XFree86-devel SDL-devel
# BuildRequires:	libalsa-static-devel nas-static-devel
ExclusiveArch:	%{ix86} ppc x86_64 amd64 sparc
# BuildRequires:	tetex-texi2html
#Requires:	x86-compat-libs
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
QEMU is a FAST! processor emulator. By using dynamic translation it
achieves a reasonnable speed while being easy to port on new host
CPUs. QEMU has two operating modes:

* User mode emulation. In this mode, QEMU can launch Linux processes
  compiled for one CPU on another CPU. Linux system calls are
  converted because of endianness and 32/64 bit mismatches. Wine
  (Windows emulation) and DOSEMU (DOS emulation) are the main targets
  for QEMU.

* Full system emulation. In this mode, QEMU emulates a full system,
  including a processor and various peripherials. Currently, it is
  only used to launch an x86 Linux kernel on an x86 Linux system. It
  enables easier testing and debugging of system code. It can also be
  used to provide virtual hosting of several virtual PC on a single
  server.

%prep
%setup -q
#%patch0 -p1 -b .i386-cvsupdates
%patch1 -p1 -b .DESTDIR
#%patch2 -p1 -b .ppc-siginfo
#%patch3 -p1 -b .sigaction
%patch4 -p0

%build
./configure --prefix=%{_prefix} --target-list="%{targets}"
%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std

# nuke explicit dependencies on GLIBC_PRIVATE
cat >find_requires.sh << EOF
#!/bin/sh
%{_prefix}/lib/rpm/find-requires %{buildroot} %{_target_cpu} | grep -v GLIBC_PRIVATE
EOF
chmod +x find_requires.sh

# remove unpackaged files
rm -rf $RPM_BUILD_ROOT%{_docdir}/qemu

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README qemu-doc.html qemu-tech.html
%{_bindir}/qemu
%{_bindir}/qemu-fast
%{_bindir}/qemu-i386
%{_bindir}/qemu-ppc
%{_bindir}/qemu-system-ppc
%{_bindir}/qemu-sparc
%{_bindir}/qemu-system-sparc
#%{_bindir}/vmdk2raw
#%{_bindir}/qemu-mkcow
%{_bindir}/qemu-img
%{_mandir}/man1/qemu.1*
%{_mandir}/man1/qemu-mkcow.1*
%dir %{_datadir}/qemu
%{_datadir}/qemu/*.bin

%changelog
* Sat Jan  8 2005 Herbert Ptzl <herbert@13thfloor.at> 0.6.1-2mdk
- added qemu-fast target
- removed non mandatory build dependancies

* Sun Nov 14 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.6.1-1mdk
- 0.6.1
- build sparc target
- add initial sparc host cpu support
- drop P0, P2 & P3 (merged upstream)
- regenerate P1

* Wed Sep 29 2004 Michael Scherer <misc@mandrake.org> 0.6.0-2mdk 
- fix memleak of userspace-net-stack, ( http://lists.gnu.org/archive/html/qemu-devel/2004-09/msg00244.html )

* Mon Sep  6 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.6.0-1mdk
- 0.6.0
- updates from CVS (2004/09/06):
  * fix x86 bound instruction
  * fix build on x86 with asm memory helpers
  * fix build on ppc

* Tue Mar 02 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.5.0-4mdk
- buildrequires

* Fri Nov  7 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-3mdk
- lib64 fixes
- update to current CVS:
  - float access fixes when using soft mmu
  - PC emulation support on PowerPC
  - A20 support

* Thu Nov  6 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-2mdk
- add initial AMD64 host cpu support

* Thu Nov  6 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.5.0-1mdk
- 0.5.0

* Fri Aug 01 2003 Michael Scherer <scherer.michael@free.fr> 0.4.1-2mdk
- BuildRequires ( glibc-static-devel ) 

* Mon Jul  7 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.4.1-1mdk
- 0.4.1

* Tue Jun  3 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.2-1mdk
- 0.2

* Sat Apr 12 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.6-1mdk
- 0.1.6

* Mon Mar 31 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.4-1mdk
- 0.1.4

* Thu Mar 27 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.1.2-1mdk
- First Mandrake Linux package
- Patch0: Fix x86 signal handler to retrieve pc from [REG_IP] slot
- Patch1: Add support for nanosecond resolution timestamps from glibc 2.3
- Patch2: Adjust ldscripts for glibc >= 2.3
- Patch3: Handle exit_group syscall as an exit
- Patch4: Add missing includes
